#include "windows.h"
#include <stdio.h>

// Foward declarations of functions included in this code module:
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
static BOOL thread_exited = FALSE;

static void create_wnd(void)
{
    HWND hWnd;
    hWnd = CreateWindow("MainWindow", "Title", WS_OVERLAPPEDWINDOW,
                        CW_USEDEFAULT, 0, 200, 200, NULL, NULL, NULL, NULL);
    ShowWindow(hWnd, SW_SHOW);
}

static DWORD wnd_proc(void)
{
    MSG msg;
    while (GetMessage(&msg, NULL, 0, 0)) 
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    fprintf(stderr, "Exiting thread\n");
    thread_exited = TRUE;
    return msg.wParam;
}

static DWORD CALLBACK thread_proc(LPVOID arg)
{
    create_wnd();
    return wnd_proc();
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
    WNDCLASSEX wcex;
    DWORD threadId;
    HANDLE thread;
    HHOOK hook;
    HMODULE hookModule = LoadLibraryA("hook.dll");
    PVOID hookProc = GetProcAddress(hookModule, "hook_proc");
    MSG msg;

    if (!hookProc || !hookModule)
    {
        fprintf(stderr, "Error loading hook dll (%ld)\n", GetLastError());
        return 1;
    }
    fprintf(stderr, "module=%p proc=%p\n", hookModule, hookProc);
    wcex.cbSize         = sizeof(WNDCLASSEX);
    wcex.style          = CS_HREDRAW | CS_VREDRAW;
    wcex.lpfnWndProc    = (WNDPROC)WndProc;
    wcex.cbClsExtra     = 0;
    wcex.cbWndExtra     = 0;
    wcex.hInstance      = hInstance;
    wcex.hIcon          = NULL;
    wcex.hCursor        = LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground  = (HBRUSH)(COLOR_WINDOW+1);
    wcex.lpszMenuName   = NULL;
    wcex.lpszClassName  = "MainWindow";
    wcex.hIconSm        = NULL;
    RegisterClassEx(&wcex);

    thread = CreateThread(NULL, 0, thread_proc, NULL, 0, &threadId);
    create_wnd();
    if (!(hook = SetWindowsHookExA(WH_MOUSE_LL, hookProc, hookModule, 0)))
        fprintf(stderr, "Error installing hook (%ld)\n", GetLastError());

    while (GetMessage(&msg, NULL, 0, 0) && !thread_exited) 
    {
        fprintf(stderr, "Got msg %lx\n", msg.message);
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    UnhookWindowsHookEx(hook);

    return 0;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message) 
    {
    case WM_DESTROY:
        PostQuitMessage(0);
        break;
    default:
        return DefWindowProc(hWnd, message, wParam, lParam);
    }
}
